#include <QuickDraw.h>
#include <MacTypes.h>
#include <FontMgr.h>
#include <WindowMgr.h>
#include <MenuMgr.h>
#include <TextEdit.h>
#include <DialogMgr.h>
#include <EventMgr.h>
#include <DeskMgr.h>
#include <StdfilePkg.h>
#include <FileMgr.h>
#include <ToolboxUtil.h>
#include <ControlMgr.h>
#include <SerialDvr.h>

#include "MBOB.h"

extern	gEOL[];

/*
		Created by 	:	Byro
		Date		:	05/10/90
		Modified	:	05/17/90
*/


HndlBaudDialog(settings)
	dlogSettingsPtr	settings;
	
{
	int				dialDone = FALSE, itemHit, itemType;
	Rect			itemRect;
	Handle			itemHandle;
	DialogPtr		BaudDialog;
	dlogSettings	oldSettings;	/* used to restore in case of cancel */
	
	
	oldSettings = *settings;
	BaudDialog = GetNewDialog(BASE_RES_ID, NIL, MOVE_TO_FRONT);
	if (BaudDialog == NIL)
	{
		StopAlert(ENOUGH_ALERT, NIL);
		return(TRUE);
	}

	SelectWindow(BaudDialog);
	SetBaud(settings, BaudDialog);	/* load current settings */
	ShowWindow(BaudDialog);			/* initially invisible */
	
	while (dialDone == FALSE)
	{
		ModalDialog(NIL, &itemHit);
		switch(itemHit)
		{
			case OK_BUTTON :
				HideWindow(BaudDialog);
				DisposDialog(BaudDialog);
				dialDone = TRUE;
				break;
			case CANCEL_BUTTON :
				HideWindow(BaudDialog);
				DisposDialog(BaudDialog);
				*settings = oldSettings;	/* load old values */
				dialDone = TRUE;
				return(CANCEL_BUTTON);
				break;
			case FIRST_RADIO :
			
				/* turn on 300 baud radio dial */
	
				GetDItem(BaudDialog, FIRST_RADIO, &itemType, &itemHandle, &itemRect);
				SetCtlValue(itemHandle, ON);
	
				GetDItem(BaudDialog, SECOND_RADIO, &itemType, &itemHandle, &itemRect);
				SetCtlValue(itemHandle, OFF);

				GetDItem(BaudDialog, THIRD_RADIO, &itemType, &itemHandle, &itemRect);
				SetCtlValue(itemHandle, OFF);

				GetDItem(BaudDialog, FOURTH_RADIO, &itemType, &itemHandle, &itemRect);
				SetCtlValue(itemHandle, OFF);
				
				GetDItem(BaudDialog, FIFTH_RADIO, &itemType, &itemHandle, &itemRect);
				SetCtlValue(itemHandle, OFF);
				
				GetDItem(BaudDialog, SIXTH_RADIO, &itemType, &itemHandle, &itemRect);
				SetCtlValue(itemHandle, OFF);
			
				settings->baud = baud300;	
			
				break;
			case SECOND_RADIO :
			
				/* turn on 1200 baud radio dial */
	
				GetDItem(BaudDialog, FIRST_RADIO, &itemType, &itemHandle, &itemRect);
				SetCtlValue(itemHandle, OFF);
	
				GetDItem(BaudDialog, SECOND_RADIO, &itemType, &itemHandle, &itemRect);
				SetCtlValue(itemHandle, ON);

				GetDItem(BaudDialog, THIRD_RADIO, &itemType, &itemHandle, &itemRect);
				SetCtlValue(itemHandle, OFF);

				GetDItem(BaudDialog, FOURTH_RADIO, &itemType, &itemHandle, &itemRect);
				SetCtlValue(itemHandle, OFF);
				
				GetDItem(BaudDialog, FIFTH_RADIO, &itemType, &itemHandle, &itemRect);
				SetCtlValue(itemHandle, OFF);
				
				GetDItem(BaudDialog, SIXTH_RADIO, &itemType, &itemHandle, &itemRect);
				SetCtlValue(itemHandle, OFF);
			
				settings->baud = baud1200;	
			
				break;
			case THIRD_RADIO :
			
				/* turn on 4800 baud radio dial */
	
				GetDItem(BaudDialog, FIRST_RADIO, &itemType, &itemHandle, &itemRect);
				SetCtlValue(itemHandle, OFF);
	
				GetDItem(BaudDialog, SECOND_RADIO, &itemType, &itemHandle, &itemRect);
				SetCtlValue(itemHandle, OFF);

				GetDItem(BaudDialog, THIRD_RADIO, &itemType, &itemHandle, &itemRect);
				SetCtlValue(itemHandle, ON);

				GetDItem(BaudDialog, FOURTH_RADIO, &itemType, &itemHandle, &itemRect);
				SetCtlValue(itemHandle, OFF);
				
				GetDItem(BaudDialog, FIFTH_RADIO, &itemType, &itemHandle, &itemRect);
				SetCtlValue(itemHandle, OFF);
				
				GetDItem(BaudDialog, SIXTH_RADIO, &itemType, &itemHandle, &itemRect);
				SetCtlValue(itemHandle, OFF);
			
				settings->baud = baud4800;	
			
				break;
		case FOURTH_RADIO :
		
				/* turn on 9600 baud radio dial */
	
				GetDItem(BaudDialog, FIRST_RADIO, &itemType, &itemHandle, &itemRect);
				SetCtlValue(itemHandle, OFF);
	
				GetDItem(BaudDialog, SECOND_RADIO, &itemType, &itemHandle, &itemRect);
				SetCtlValue(itemHandle, OFF);

				GetDItem(BaudDialog, THIRD_RADIO, &itemType, &itemHandle, &itemRect);
				SetCtlValue(itemHandle, OFF);

				GetDItem(BaudDialog, FOURTH_RADIO, &itemType, &itemHandle, &itemRect);
				SetCtlValue(itemHandle, ON);
				
				GetDItem(BaudDialog, FIFTH_RADIO, &itemType, &itemHandle, &itemRect);
				SetCtlValue(itemHandle, OFF);
				
				GetDItem(BaudDialog, SIXTH_RADIO, &itemType, &itemHandle, &itemRect);
				SetCtlValue(itemHandle, OFF);
			
				settings->baud = baud9600;	
			
				break;
			case FIFTH_RADIO :
			
				/* turn on 19200 baud radio dial */
	
				GetDItem(BaudDialog, FIRST_RADIO, &itemType, &itemHandle, &itemRect);
				SetCtlValue(itemHandle, OFF);
	
				GetDItem(BaudDialog, SECOND_RADIO, &itemType, &itemHandle, &itemRect);
				SetCtlValue(itemHandle, OFF);

				GetDItem(BaudDialog, THIRD_RADIO, &itemType, &itemHandle, &itemRect);
				SetCtlValue(itemHandle, OFF);

				GetDItem(BaudDialog, FOURTH_RADIO, &itemType, &itemHandle, &itemRect);
				SetCtlValue(itemHandle, OFF);
				
				GetDItem(BaudDialog, FIFTH_RADIO, &itemType, &itemHandle, &itemRect);
				SetCtlValue(itemHandle, ON);
				
				GetDItem(BaudDialog, SIXTH_RADIO, &itemType, &itemHandle, &itemRect);
				SetCtlValue(itemHandle, OFF);
			
				settings->baud = baud19200;	
			
				break;
			case SIXTH_RADIO :
			
				/* turn on 57600 baud radio dial */
	
				GetDItem(BaudDialog, FIRST_RADIO, &itemType, &itemHandle, &itemRect);
				SetCtlValue(itemHandle, OFF);
	
				GetDItem(BaudDialog, SECOND_RADIO, &itemType, &itemHandle, &itemRect);
				SetCtlValue(itemHandle, OFF);

				GetDItem(BaudDialog, THIRD_RADIO, &itemType, &itemHandle, &itemRect);
				SetCtlValue(itemHandle, OFF);

				GetDItem(BaudDialog, FOURTH_RADIO, &itemType, &itemHandle, &itemRect);
				SetCtlValue(itemHandle, OFF);
				
				GetDItem(BaudDialog, FIFTH_RADIO, &itemType, &itemHandle, &itemRect);
				SetCtlValue(itemHandle, OFF);
				
				GetDItem(BaudDialog, SIXTH_RADIO, &itemType, &itemHandle, &itemRect);
				SetCtlValue(itemHandle, ON);
			
				settings->baud = baud57600;	
			
				break;
			default :
				break;
		}
	}
	return(NIL);	/* all ok */
}




HndlParityDialog(settings)
	dlogSettingsPtr	settings;
	
{
	int				dialDone = FALSE, itemHit, itemType;
	Rect			itemRect;
	Handle			itemHandle;
	DialogPtr		ParityDialog;
	dlogSettings	oldSettings;	/* used to restore in case of cancel */
	
	oldSettings = *settings;
	
	ParityDialog = GetNewDialog(BASE_RES_ID + 1, NIL, MOVE_TO_FRONT);
	if (ParityDialog == NIL)
	{
		StopAlert(ENOUGH_ALERT, NIL);
		return(TRUE);
	}
	
	SelectWindow(ParityDialog);
	SetParity(settings, ParityDialog);
	ShowWindow(ParityDialog);		/* initially invisible */
	
	while (dialDone == FALSE)
	{
		ModalDialog(NIL, &itemHit);
		switch(itemHit)
		{
			case OK_BUTTON :
				HideWindow(ParityDialog);
				DisposDialog(ParityDialog);
				dialDone = TRUE;
				break;
			case CANCEL_BUTTON :
				HideWindow(ParityDialog);
				DisposDialog(ParityDialog);
				*settings = oldSettings;	/* load old values */
				dialDone = TRUE;
				return(CANCEL_BUTTON);
				break;
			case FIRST_RADIO :
			
				/* turn on even parity radio dial */
	
				GetDItem(ParityDialog, FIRST_RADIO, &itemType, &itemHandle, &itemRect);
				SetCtlValue(itemHandle, ON);
	
				GetDItem(ParityDialog, SECOND_RADIO, &itemType, &itemHandle, &itemRect);
				SetCtlValue(itemHandle, OFF);

				GetDItem(ParityDialog, THIRD_RADIO, &itemType, &itemHandle, &itemRect);
				SetCtlValue(itemHandle, OFF);

				settings->parity = evenParity;
				
				break;
			case SECOND_RADIO :
			
				/* turn on no parity radio dial */
				
				GetDItem(ParityDialog, FIRST_RADIO, &itemType, &itemHandle, &itemRect);
				SetCtlValue(itemHandle, OFF);
	
				GetDItem(ParityDialog, SECOND_RADIO, &itemType, &itemHandle, &itemRect);
				SetCtlValue(itemHandle, ON);

				GetDItem(ParityDialog, THIRD_RADIO, &itemType, &itemHandle, &itemRect);
				SetCtlValue(itemHandle, OFF);

				settings->parity = noParity;
				
				break;
			case THIRD_RADIO :
			
				/* turn on odd parity radio dial */
				
				GetDItem(ParityDialog, FIRST_RADIO, &itemType, &itemHandle, &itemRect);
				SetCtlValue(itemHandle, OFF);
	
				GetDItem(ParityDialog, SECOND_RADIO, &itemType, &itemHandle, &itemRect);
				SetCtlValue(itemHandle, OFF);

				GetDItem(ParityDialog, THIRD_RADIO, &itemType, &itemHandle, &itemRect);
				SetCtlValue(itemHandle, ON);

				settings->parity = oddParity;
				
				break;
			default :
				break;
		}
	}
	return(NIL);	/* all ok */
}




HndlStopBitsDialog(settings)
	dlogSettingsPtr	settings;
	
{
	int			dialDone = FALSE, itemHit, itemType;
	Rect		itemRect;
	Handle		itemHandle;
	DialogPtr	StopBitsDialog;
	dlogSettings	oldSettings;	/* used to restore in case of cancel */
	
	oldSettings = *settings;
	
	StopBitsDialog = GetNewDialog(BASE_RES_ID + 2, NIL, MOVE_TO_FRONT);
	if (StopBitsDialog == NIL)
	{
		StopAlert(ENOUGH_ALERT, NIL);
		return(TRUE);
	}
	
	SelectWindow(StopBitsDialog);
	SetStopBits(settings, StopBitsDialog);
	ShowWindow(StopBitsDialog);		/* initially invisible */
	
	while (dialDone == FALSE)
	{
		ModalDialog(NIL, &itemHit);
		switch(itemHit)
		{
			case OK_BUTTON :
				HideWindow(StopBitsDialog);
				DisposDialog(StopBitsDialog);
				dialDone = TRUE;
				break;
			case CANCEL_BUTTON :
				HideWindow(StopBitsDialog);
				DisposDialog(StopBitsDialog);
				*settings = oldSettings;		/* load old values */
				dialDone = TRUE;
				return(CANCEL_BUTTON);
				break;
			case FIRST_RADIO :
			
				/* turn on 1 stop bit radio dial */
	
				GetDItem(StopBitsDialog, FIRST_RADIO, &itemType, &itemHandle, &itemRect);
				SetCtlValue(itemHandle, ON);
	
				GetDItem(StopBitsDialog, SECOND_RADIO, &itemType, &itemHandle, &itemRect);
				SetCtlValue(itemHandle, OFF);

				settings->stopBits = stop10;
				
				break;
			case SECOND_RADIO :
			
				/* turn on 2 stop bits radio dial */
				
				GetDItem(StopBitsDialog, FIRST_RADIO, &itemType, &itemHandle, &itemRect);
				SetCtlValue(itemHandle, OFF);
	
				GetDItem(StopBitsDialog, SECOND_RADIO, &itemType, &itemHandle, &itemRect);
				SetCtlValue(itemHandle, ON);

				settings->stopBits = stop20;
				
				break;
				
			default :
				break;
		}
	}
	return(NIL);	/* all ok */
}




HndlFilterDialog(settings)
	dlogSettingsPtr	settings;
	
{	
	int			dialDone = FALSE, filterChar, itemHit, itemType;
	Rect		itemRect;
	Handle		itemHandle;
	DialogPtr	FilterDialog;
	Str255		CfilterString, filterString;
	
	settings->filter = 0;
	FilterDialog = GetNewDialog(BASE_RES_ID + 3, NIL, MOVE_TO_FRONT);
	if (FilterDialog == NIL)
	{
		StopAlert(ENOUGH_ALERT, NIL);
		return(TRUE);
	}
	
	SelectWindow(FilterDialog);
	ShowWindow(FilterDialog);		/* initially invisible */
	
	while (dialDone == FALSE)
	{
		ModalDialog(NIL, &itemHit);
		switch(itemHit)
		{
			case OK_BUTTON :
				HideWindow(FilterDialog);
				DisposDialog(FilterDialog);
								
				/* be sure and check this for valid input */
				
				if (*filterString != *gEOL)
				{
					if (isItADigit(filterString) == TRUE)
					{
					
						/* string ok */
						
						P2Cstr(filterString, CfilterString);
						filterChar = atoi(CfilterString);
						
						/* range check */
						
						if (filterChar < 256)
							settings->filter = filterChar;
						else
						{
							; /* display error dialog */
						}
					}
					else
						return(TRUE);	/* err condition */
				}
				dialDone = TRUE;
				break;
			case CANCEL_BUTTON :
				HideWindow(FilterDialog);
				DisposDialog(FilterDialog);
				dialDone = TRUE;
				return(CANCEL_BUTTON);
				break;
			case FILTER_ITEM :
			
				/* get filter value from dialog */
					
				GetDItem(FilterDialog, FILTER_ITEM, &itemType,
							&itemHandle, &itemRect);
				GetIText(itemHandle, filterString);
				break;
			default :
				break;
		}
	}
	return(NIL);	/* all ok */
}




SetBaud(Settings, dlogPtr)
	dlogSettingsPtr	Settings;
	DialogPtr		dlogPtr;
	
/*
		sets radio buttons in baud rate dialog according to values in
	the settings structure.
*/

{
	int			itemHit, itemType;
	Rect		itemRect;
	Handle		itemHandle;

	switch (Settings->baud)
	{
		case baud300 :
		
			/* turn on 300 baud radio dial */
	
			GetDItem(dlogPtr, FIRST_RADIO, &itemType, &itemHandle, &itemRect);
			SetCtlValue(itemHandle, ON);
	
			GetDItem(dlogPtr, SECOND_RADIO, &itemType, &itemHandle, &itemRect);
			SetCtlValue(itemHandle, OFF);

			GetDItem(dlogPtr, THIRD_RADIO, &itemType, &itemHandle, &itemRect);
			SetCtlValue(itemHandle, OFF);

			GetDItem(dlogPtr, FOURTH_RADIO, &itemType, &itemHandle, &itemRect);
			SetCtlValue(itemHandle, OFF);
				
			GetDItem(dlogPtr, FIFTH_RADIO, &itemType, &itemHandle, &itemRect);
			SetCtlValue(itemHandle, OFF);
				
			GetDItem(dlogPtr, SIXTH_RADIO, &itemType, &itemHandle, &itemRect);
			SetCtlValue(itemHandle, OFF);
			break;
				
		case baud1200 :
			
			/* turn on 1200 baud radio dial */
	
			GetDItem(dlogPtr, FIRST_RADIO, &itemType, &itemHandle, &itemRect);
			SetCtlValue(itemHandle, OFF);
	
			GetDItem(dlogPtr, SECOND_RADIO, &itemType, &itemHandle, &itemRect);
			SetCtlValue(itemHandle, ON);

			GetDItem(dlogPtr, THIRD_RADIO, &itemType, &itemHandle, &itemRect);
			SetCtlValue(itemHandle, OFF);

			GetDItem(dlogPtr, FOURTH_RADIO, &itemType, &itemHandle, &itemRect);
			SetCtlValue(itemHandle, OFF);
				
			GetDItem(dlogPtr, FIFTH_RADIO, &itemType, &itemHandle, &itemRect);
			SetCtlValue(itemHandle, OFF);
				
			GetDItem(dlogPtr, SIXTH_RADIO, &itemType, &itemHandle, &itemRect);
			SetCtlValue(itemHandle, OFF);
			break;
				
		case baud4800 :
			
			/* turn on 4800 baud radio dial */
	
			GetDItem(dlogPtr, FIRST_RADIO, &itemType, &itemHandle, &itemRect);
			SetCtlValue(itemHandle, OFF);
	
			GetDItem(dlogPtr, SECOND_RADIO, &itemType, &itemHandle, &itemRect);
			SetCtlValue(itemHandle, OFF);

			GetDItem(dlogPtr, THIRD_RADIO, &itemType, &itemHandle, &itemRect);
			SetCtlValue(itemHandle, ON);

			GetDItem(dlogPtr, FOURTH_RADIO, &itemType, &itemHandle, &itemRect);
			SetCtlValue(itemHandle, OFF);
				
			GetDItem(dlogPtr, FIFTH_RADIO, &itemType, &itemHandle, &itemRect);
			SetCtlValue(itemHandle, OFF);
				
			GetDItem(dlogPtr, SIXTH_RADIO, &itemType, &itemHandle, &itemRect);
			SetCtlValue(itemHandle, OFF);
			break;
				
		case baud9600 :
		
			/* turn on 9600 baud radio dial */
	
			GetDItem(dlogPtr, FIRST_RADIO, &itemType, &itemHandle, &itemRect);
			SetCtlValue(itemHandle, OFF);
	
			GetDItem(dlogPtr, SECOND_RADIO, &itemType, &itemHandle, &itemRect);
			SetCtlValue(itemHandle, OFF);

			GetDItem(dlogPtr, THIRD_RADIO, &itemType, &itemHandle, &itemRect);
			SetCtlValue(itemHandle, OFF);

			GetDItem(dlogPtr, FOURTH_RADIO, &itemType, &itemHandle, &itemRect);
			SetCtlValue(itemHandle, ON);
				
			GetDItem(dlogPtr, FIFTH_RADIO, &itemType, &itemHandle, &itemRect);
			SetCtlValue(itemHandle, OFF);
				
			GetDItem(dlogPtr, SIXTH_RADIO, &itemType, &itemHandle, &itemRect);
			SetCtlValue(itemHandle, OFF);
			break;
				
		case baud19200 :
			
			/* turn on 19200 baud radio dial */
	
			GetDItem(dlogPtr, FIRST_RADIO, &itemType, &itemHandle, &itemRect);
			SetCtlValue(itemHandle, OFF);
	
			GetDItem(dlogPtr, SECOND_RADIO, &itemType, &itemHandle, &itemRect);
			SetCtlValue(itemHandle, OFF);

			GetDItem(dlogPtr, THIRD_RADIO, &itemType, &itemHandle, &itemRect);
			SetCtlValue(itemHandle, OFF);

			GetDItem(dlogPtr, FOURTH_RADIO, &itemType, &itemHandle, &itemRect);
			SetCtlValue(itemHandle, OFF);
				
			GetDItem(dlogPtr, FIFTH_RADIO, &itemType, &itemHandle, &itemRect);
			SetCtlValue(itemHandle, ON);
				
			GetDItem(dlogPtr, SIXTH_RADIO, &itemType, &itemHandle, &itemRect);
			SetCtlValue(itemHandle, OFF);
			break;
				
		case baud57600 :
			
			/* turn on 57600 baud radio dial */
	
			GetDItem(dlogPtr, FIRST_RADIO, &itemType, &itemHandle, &itemRect);
			SetCtlValue(itemHandle, OFF);
	
			GetDItem(dlogPtr, SECOND_RADIO, &itemType, &itemHandle, &itemRect);
			SetCtlValue(itemHandle, OFF);

			GetDItem(dlogPtr, THIRD_RADIO, &itemType, &itemHandle, &itemRect);
			SetCtlValue(itemHandle, OFF);

			GetDItem(dlogPtr, FOURTH_RADIO, &itemType, &itemHandle, &itemRect);
			SetCtlValue(itemHandle, OFF);
				
			GetDItem(dlogPtr, FIFTH_RADIO, &itemType, &itemHandle, &itemRect);
			SetCtlValue(itemHandle, OFF);
				
			GetDItem(dlogPtr, SIXTH_RADIO, &itemType, &itemHandle, &itemRect);
			SetCtlValue(itemHandle, ON);			
			break;
				
		default :
			break;
	}
}




SetParity(settings, dlogPtr)
	dlogSettingsPtr	settings;
	DialogPtr		dlogPtr;
	
/*
		Sets Parity defaults in input dialog.
*/

{
	int			itemHit, itemType;
	Rect		itemRect;
	Handle		itemHandle;

	switch (settings->parity)
	{
		case evenParity :
			
			/* turn on even parity radio dial */
	
			GetDItem(dlogPtr, FIRST_RADIO, &itemType, &itemHandle, &itemRect);
			SetCtlValue(itemHandle, ON);
	
			GetDItem(dlogPtr, SECOND_RADIO, &itemType, &itemHandle, &itemRect);
			SetCtlValue(itemHandle, OFF);

			GetDItem(dlogPtr, THIRD_RADIO, &itemType, &itemHandle, &itemRect);
			SetCtlValue(itemHandle, OFF);
			break;
				
		case noParity :
			
			/* turn on no parity radio dial */
				
			GetDItem(dlogPtr, FIRST_RADIO, &itemType, &itemHandle, &itemRect);
			SetCtlValue(itemHandle, OFF);
	
			GetDItem(dlogPtr, SECOND_RADIO, &itemType, &itemHandle, &itemRect);
			SetCtlValue(itemHandle, ON);

			GetDItem(dlogPtr, THIRD_RADIO, &itemType, &itemHandle, &itemRect);
			SetCtlValue(itemHandle, OFF);
			break;
				
		case oddParity :
			
			/* turn on odd parity radio dial */
				
			GetDItem(dlogPtr, FIRST_RADIO, &itemType, &itemHandle, &itemRect);
			SetCtlValue(itemHandle, OFF);
	
			GetDItem(dlogPtr, SECOND_RADIO, &itemType, &itemHandle, &itemRect);
			SetCtlValue(itemHandle, OFF);

			GetDItem(dlogPtr, THIRD_RADIO, &itemType, &itemHandle, &itemRect);
			SetCtlValue(itemHandle, ON);
			break;
				
		default :
			break;
	}
}




SetStopBits(settings, dlogPtr)
	dlogSettingsPtr	settings;
	DialogPtr		dlogPtr;
	
/*
		Sets Stop Bit(s) defaults in input dialog.
*/

{
	int			itemHit, itemType;
	Rect		itemRect;
	Handle		itemHandle;

	switch (settings->stopBits)
	{
		case stop10 :
			
			/* turn on 1 stop bit radio dial */
	
			GetDItem(dlogPtr, FIRST_RADIO, &itemType, &itemHandle, &itemRect);
			SetCtlValue(itemHandle, ON);
	
			GetDItem(dlogPtr, SECOND_RADIO, &itemType, &itemHandle, &itemRect);
			SetCtlValue(itemHandle, OFF);
			break;
			
		case stop20 :
			
			/* turn on 2 stop bits radio dial */
				
			GetDItem(dlogPtr, FIRST_RADIO, &itemType, &itemHandle, &itemRect);
			SetCtlValue(itemHandle, OFF);
	
			GetDItem(dlogPtr, SECOND_RADIO, &itemType, &itemHandle, &itemRect);
			SetCtlValue(itemHandle, ON);
			break;
				
		default :
			break;
	}
}
