/*#include <storage.h>*/


#include <QuickDraw.h>
#include <MacTypes.h>
#include <FontMgr.h>
#include <WindowMgr.h>
#include <MenuMgr.h>
#include <TextEdit.h>
#include <DialogMgr.h>
#include <EventMgr.h>
#include <DeskMgr.h>
#include <StdfilePkg.h>
#include <FileMgr.h>
#include <ToolboxUtil.h>
#include <ControlMgr.h>
#include <SerialDvr.h>

#include "MBOB.h"


/* 		Mac Break Out Box is an application that allows the Mac to act as a
	logical breakout box.
	The following are included as part of the project:
			
			mactraps lib
			storage lib
			strings lib
			mbob.c
			mbob functs.c
			dlogs.c
			utils.c
			
	
					Written by :	Byro
					Date :			05/07/90
					Modified :		06/22/90
					
					
		Version Log:
						1.0 initial release
*/


/*************	globals	***************/

char gCR[] = "\r";
char gTAB[] = "\t";
char gSP[] = " ";	/* space */
char gEOL[] = "\0";


main()

{

	Boolean			doneFlag = FALSE, WNEImplemented;
	dlogSettings	mySettings;
	EventRecord		myEvent;
	Handle			ClipHandle;
	MenuHandle		AppleMenu;
	Rect			DragRect;
	WindowPtr		StatWindow,
					ClipboardWindow;

	ToolBoxInit();
	WindowInit(&StatWindow, "\pStatus Window");
	SetUpDragRect(&DragRect);
	MenuBarInit(&AppleMenu);
	CreateClipBoardWindow(&ClipboardWindow);
	ClipHandle = NewHandle(NIL);
	InitSerial(&mySettings);
	MainLoop(&doneFlag, &myEvent, &WNEImplemented, &DragRect, &AppleMenu,
				&StatWindow, &ClipboardWindow, &ClipHandle, &mySettings);

}

/****************************************************************************************/

ToolBoxInit()	
	
	/* initialization */

{	
	InitGraf(&thePort);
	InitFonts();
	FlushEvents( everyEvent, REMOVE_ALL_EVENTS );
	InitWindows();
	InitMenus();
	TEInit();
	InitDialogs(NIL);
	InitCursor();
}

/****************************************************************************************/

WindowInit(aWindow, windowTitle)
	WindowPtr	*aWindow;
	Str255		*windowTitle;
	
{	
	/* init window ptr */
	
	*aWindow = GetNewWindow(BASE_RES_ID, NIL, MOVE_TO_FRONT);
	
	/* if can't open window let user know */
	
	if (*aWindow == NIL)
	{
		/* system dialog goes here */
		
		StopAlert(EMPTY_ALERT, NIL);
		ExitToShell();	/* ciao */
	}
	
	if (**windowTitle != NIL)
		SetWTitle(*aWindow, windowTitle);
	
	SetPort(*aWindow);		/* make current graf port */

}

/****************************************************************************************/

SetUpDragRect(DragRect)
	Rect	*DragRect;
	
{
	*DragRect = screenBits.bounds;
	(*DragRect).left += DRAG_THRESHOLD;
	(*DragRect).right -= DRAG_THRESHOLD;
	(*DragRect).bottom -= DRAG_THRESHOLD;
}

/****************************************************************************************/

MenuBarInit(AppleMenu)
	MenuHandle	*AppleMenu;
	
{
	Handle	myMenuBar;
	
	myMenuBar = GetNewMBar(BASE_RES_ID);
	SetMenuBar(myMenuBar);
	*AppleMenu = GetMHandle(APPLE_MENU_ID);
	AddResMenu(*AppleMenu, 'DRVR');
	DrawMenuBar();
}

/****************************************************************************************/

CreateClipBoardWindow(ClipBoardWindow)
	WindowPtr	*ClipBoardWindow;
	
{

	if (( *ClipBoardWindow = GetNewWindow(BASE_RES_ID, NIL, MOVE_TO_FRONT))  == NIL)
	{
		NoteAlert(CLIPBOARD_ALERT, NIL);
		/* ExitToShell(); */
	}
	
	/* set window title */
	
	SetWTitle(*ClipBoardWindow, "\p ClipBoard");
	
	MoveWindow(*ClipBoardWindow, WINDOW_HOME_LEFT, WINDOW_HOME_RIGHT, 
					LEAVE_WHERE_IT_IS);
}

/****************************************************************************************/

MainLoop(doneFlag, myEvent, WNEImplemented, DragRect, AppleMenu, 
						StatWindow, CBWindow, clipHandle, MySettings)
	Boolean			*doneFlag;
	EventRecord		*myEvent;
	Boolean			*WNEImplemented;
	Rect			*DragRect;
	MenuHandle		*AppleMenu;
	WindowPtr		*StatWindow,
					*CBWindow;
	Handle			*clipHandle;
	dlogSettingsPtr	MySettings;
	
{
	int			filterKount = 0;
	SerStaRec	serStat;			/* serial status record */

	/* check to see if multifinder running */
	
	*WNEImplemented = (NGetTrapAddress(WNE_TRAP_NUM, ToolTrap) != 
						NGetTrapAddress(UNIMPL_TRAP_NUM, ToolTrap));
						
	/* main program/Event loop */
	
	do
	{
		/* check serial port for input and process if necessary */
	
		doSerial(StatWindow, MySettings, &serStat, &filterKount);
		
		HandleEvent(doneFlag, myEvent, WNEImplemented, DragRect,
						AppleMenu, StatWindow, CBWindow, clipHandle,
						MySettings, &serStat, &filterKount);
	}	
	while (*doneFlag == FALSE);
	shutdownAppl();					/* ciao */
}

/****************************************************************************************/

HandleEvent(doneFlag, myEvent, WNEImplemented, DragRect, AppleMenu, 
				StatWindow, CbWindow, clipHandl, meSettings,
				serStatPtr, fKountPtr)
	Boolean			*doneFlag;
	EventRecord		*myEvent;
	Boolean			*WNEImplemented;
	Rect			*DragRect;
	MenuHandle		*AppleMenu;
	WindowPtr		*StatWindow,
					*CbWindow;
	Handle			*clipHandl;
	dlogSettingsPtr	meSettings;
	SerStaRec		*serStatPtr;
	int				*fKountPtr;
	
{
	char 			theChar;
	Rect			myClip, oldClip;
	WindowPtr		oldPort;				/* contains current graph port */
	static Boolean	monitorStream = FALSE;
			
	/* multifinder check */
	
	if (*WNEImplemented)
		WaitNextEvent(everyEvent, myEvent, SLEEP, NIL_MOUSE_REGION);
	else
	{
		SystemTask();	/* time slice for OS */
		GetNextEvent(everyEvent, myEvent);
	}
		
	switch ((*myEvent).what)
	{
		case	mouseDown:
			HandleMouseDown(doneFlag, myEvent,WNEImplemented, DragRect, AppleMenu,
							&monitorStream, StatWindow, CbWindow, meSettings);
			break;

		case	nullEvent:
		case	mouseUp:
		case	keyUp:
		case	updateEvt:

			/* 
				see if update is for this window or monitor stream menu selected 
				& redraw window if either condition true.
			*/
			
			if (((WindowPtr) (*myEvent).message == *StatWindow) || (monitorStream == TRUE))
			{				
				
				/* reset filter counter when monitoring starts */
				
				if (monitorStream == TRUE)
				{
					*fKountPtr = 0;
					ZeroStruct(serStatPtr, sizeof(SerStaRec));
					SelectWindow(*StatWindow);
					ShowWindow(*StatWindow);
				}
				
				SysBeep(4);
				BeginUpdate(*StatWindow);
					
				GetPort(&oldPort);						/* save current graph port */
				SetPort(*StatWindow);
				EraseRect(&(*StatWindow)->portRect);
				displayStatus(serStatPtr, *fKountPtr);
				SetPort(oldPort);						/* restore old graph port */
				EndUpdate(*StatWindow);
				monitorStream = FALSE;	/* reset after use */
			}
			
			/* chk if update for clip board window */
			
			if ((WindowPtr) (*myEvent).message == *CbWindow)
			{
				BeginUpdate(*CbWindow);
				GetPort(&oldPort);						/* save current graph port */
				SetPort(*CbWindow);
				EraseRect(&(*CbWindow)->portRect);
				
				/* clip scrollbar sections of clipboard */
				
				SetRect(&myClip, (*CbWindow)->portRect.left, (*CbWindow)->portRect.top,
						(*CbWindow)->portRect.right, (*CbWindow)->portRect.bottom);
				oldClip = myClip;	/* save old portrect  */
				myClip.bottom -= SCROLL_BAR_PIXELS;
				myClip.right -= SCROLL_BAR_PIXELS;
				ClipRect(&myClip); 
				
				DisplayClipboard(CbWindow, clipHandl);
				ClipRect(&oldClip);						/* restore old clip region */
				DrawGrowIcon(*CbWindow);
				ShowWindow(*CbWindow);
				SetPort(oldPort);						/* restore old graph port */
				EndUpdate(*CbWindow);
			}
			break;
		case	keyDown:
		case	autoKey:
			theChar = (*myEvent).message & charCodeMask;
			if (((*myEvent).modifiers & cmdKey) != 0)
				HandleMenuChoice(MenuKey(theChar), doneFlag, AppleMenu, 
									&monitorStream, CbWindow, meSettings);
			break;
		case	activateEvt:
			break;
		default:
			break;
	}
}

/****************************************************************************************/

HandleMouseDown(doneFlag, myEvent, WNEImplemented, DragRect, AppleMenu, 
				monStreamPtr, statWindow, cBwindow, MeSettings)
	Boolean			*doneFlag;
	EventRecord		*myEvent;
	Boolean			*WNEImplemented;
	Rect			*DragRect;
	MenuHandle		*AppleMenu;
	Boolean			*monStreamPtr;
	WindowPtr		*statWindow,
					*cBwindow;
	dlogSettingsPtr	MeSettings;
	
{
	Boolean			StillInGoAway, updateBackdrop = FALSE;
	WindowPtr		whichWindow;
	short int		thePart;
	long int		menuChoice;
	MenuHandle		disableHandle;
	long			nuSize;
	Rect			limitRect;
	
	WindowPtr		oldPort;
	
	thePart = FindWindow((*myEvent).where, &whichWindow);
	GetPort(&oldPort);	/* save current graph port  */
	switch(thePart)
	{
		case	inContent:
					/* activate the window that was pt'd @  */
							
					SetPort(whichWindow);
					SelectWindow(whichWindow);
					break;
		case	inMenuBar:
					menuChoice = MenuSelect((*myEvent).where);
					HandleMenuChoice(menuChoice, doneFlag, AppleMenu, 
									monStreamPtr, cBwindow, MeSettings);
					break;
		case	inSysWindow:
					SystemClick(myEvent, whichWindow);
					break;
		case	inDrag:
					DragWindow(whichWindow, (*myEvent).where, DragRect);
					updateBackdrop = TRUE;
					break;
		case	inGoAway:
					/* highlight close box when clicked */
							
					StillInGoAway = TrackGoAway(whichWindow, (*myEvent).where);
					if (StillInGoAway)
					{
						/* re-enable menu selection when window closed */
								
						if (whichWindow == *statWindow)
						{
							disableHandle = GetMHandle(FILE_MENU_ID);
							EnableItem(disableHandle, OPEN_ITEM);
						}
								
						if (whichWindow == *cBwindow)
						{
							disableHandle = GetMHandle(EDIT_MENU_ID);
							EnableItem(disableHandle, CLIPBOARD_ITEM);
						}
						
						updateBackdrop = TRUE;
								
						/* restore old graph port */
								
						SetPort(oldPort);
						HideWindow(whichWindow);
						SendBehind(whichWindow, NIL);
					}
					break;
		case	inGrow:
					if (whichWindow == *cBwindow)
					{
						/* determine min, max dimensions, based on screen here */
							
						SetRect(&limitRect, 80, 80, screenBits.bounds.right,
								screenBits.bounds.bottom);
							
						/* get nu dimensions of window */
									
						nuSize = GrowWindow(whichWindow, (*myEvent).where,
											&limitRect);
												
						/* resize window */
							
						SizeWindow(whichWindow, LoWord(nuSize), HiWord(nuSize), TRUE);
						GetPort(&oldPort);	/* save current graph port  */
						SetPort(whichWindow);
						InvalRect(&whichWindow->portRect);	/* generate update evnt */
						
						/* restore old graph port */
								
						SetPort(oldPort);
						updateBackdrop = TRUE;
					}
					break;
		default:
					break;
	}
	
	/* generate update evnt for back ground window if condition met */
	
	if (updateBackdrop == TRUE)
		InvalRect(&(*statWindow)->portRect);
}

/****************************************************************************************/

HandleMenuChoice(menuChoice, doneFlag, AppleMenu, monSptr, cbWindow, MySetngs)
	long			menuChoice;
	Boolean			*doneFlag;
	MenuHandle		*AppleMenu;
	Boolean			*monSptr;
	WindowPtr		*cbWindow;
	dlogSettingsPtr	MySetngs;

{
	int theMenu;
	int theItem;
		
	if (menuChoice != FALSE)
	{
		theMenu = HiWord(menuChoice);
		theItem = LoWord(menuChoice);
		switch (theMenu)
		{
			case APPLE_MENU_ID:
								HandleAppleChoice(theItem, AppleMenu);
								break;
			case EDIT_MENU_ID:
								HandleEditChoice(theItem, cbWindow);
								break;
			case FILE_MENU_ID:
								HandleFileChoice(theItem, doneFlag, monSptr);
								break;
			case OPTION_MENU_ID:
								HandleOptionsChoice(theItem, MySetngs);
								break;
			default:
								break;
		}
		HiliteMenu(0);
	}
}

/****************************************************************************************/

HandleAppleChoice(theItem, AppleMenu)
	int theItem;
	MenuHandle	*AppleMenu;

{
	Str255 		accName;
	int			accNumber;
	short int	itemNumber;
	DialogPtr	AboutDialog;
	
	switch (theItem)
	{
		case ABOUT_ITEM:
							NoteAlert(ABOUT_ALERT, NIL);
							break;
		default:	
							GetItem(*AppleMenu, theItem, accName);
							accNumber = OpenDeskAcc(accName);
							break;
	}
}

/****************************************************************************************/

HandleEditChoice(theItem, theCbWindow)
	int			theItem;
	WindowPtr	*theCbWindow;
	
{
	int Err;
	long	*myPtr, Ptr = 0;
	MenuHandle	editHandle;
	
	myPtr = &Ptr;
	
	/* generate update evnt for clipboard window */
	
	switch (theItem)
	{
		case COPY_ITEM:
						/* defined by application */
						break;
		case PASTE_ITEM:
						/* defined by application */
						break;
		case CLEAR_ITEM:
						/* clear clipboard; refer to I.M. I:385-386, I:461 */
							
						ZeroScrap();
						PutScrap(4, 'PAT', myPtr);
						InvalRect(&(*theCbWindow)->portRect);
						break;
		case CLIPBOARD_ITEM:
						/* disable item when selected */
							
						editHandle = GetMHandle(EDIT_MENU_ID);
						DisableItem(editHandle, CLIPBOARD_ITEM);
							
						SelectWindow(*theCbWindow);
						ShowWindow(*theCbWindow);
						break;
		default:
						break;
	}
}

/****************************************************************************************/

HandleFileChoice(theItem, doneFlag, mSPtr)
	int 	theItem;
	Boolean	*doneFlag,
			*mSPtr;					/* monitor stream ptr */

{
	OSErr 		DoLaunch();		/* forward declaration */
	Boolean 	SubLaunch;		/* sublaunch if true and launch if false */
	int			Err = noErr;
	MenuHandle	fileHandle;
	
	switch (theItem)
	{
		case OPEN_ITEM:
						/* disable item when selected */
							
						fileHandle = GetMHandle(FILE_MENU_ID);
						DisableItem(fileHandle, OPEN_ITEM);
							
						*mSPtr = TRUE;
						break;
		case TRANSFER_ITEM:
						/* quits current routine after launch */
						
						SubLaunch = FALSE;	
						Err = DoLaunch(SubLaunch); 
						break;
		case LAUNCH_ITEM:
						SubLaunch = TRUE;	/* doesn't quit after launch */
						Err = DoLaunch(SubLaunch);
						break;
		case QUIT_ITEM:
						*doneFlag = TRUE;
						break;
	}
	
	/* handle launch failure */
	
	if (Err != noErr)
		NoteAlert(LAUNCH_ALERT, NIL);
}

/****************************************************************************************/

HandleOptionsChoice(theItem, mySetngs)
	int	theItem;
	dlogSettingsPtr	mySetngs;

{
	int				Err = noErr;
	
	/* load default settings here */
	
	switch (theItem)
	{
		case BAUD_ITEM :
						Err = HndlBaudDialog(mySetngs);
						break;
		case PARITY_ITEM :
						Err = HndlParityDialog(mySetngs);
						break;
		case STOP_ITEM :
						Err = HndlStopBitsDialog(mySetngs);
						break;
		case FILTER_ITEM :
						Err = HndlFilterDialog(mySetngs);
						break;
		default :
						break;
	}
		
	/* exit program if memory exhausted */
	
	if (Err == TRUE)
	{
		shutdownAppl();  /* close serial drvr and exit*/
	}

	if (Err != CANCEL_BUTTON)
	{
		/* reset serial drvrs and load nu settings vals */
		
		ChangeSettings(mySetngs);
	}
	
}

/****************************************************************************************/

DisplayClipboard(BoardWindow, ClipHandle)
	WindowPtr	*BoardWindow;
	Handle		*ClipHandle;
	
/* displays either text or pict clipboard item */

{
	Rect	myRect;
	long	length,
			offset;
			
	if ((length = GetScrap(*ClipHandle, 'TEXT', &offset)) < 0)
	{
		if ((length = GetScrap(*ClipHandle, 'PICT', &offset)) < 0)
			;/* NoteAlert(CLIPBOARD_ALERT, NIL); */
		else
		{
			/* display pict data */
			
			myRect = (*BoardWindow)->portRect;
			CenterPict(*ClipHandle, &myRect);
			DrawPicture(*ClipHandle, &myRect);
		}
	}
	else
	{
		/* display text data */
		
		HLock(*ClipHandle);
		TextBox(**ClipHandle, length, &(thePort->portRect), teJustLeft);
		HUnlock(*ClipHandle);
	}
}

/****************************************************************************************/

OSErr LaunchIt(pLnch)
	pLaunchStruct pLnch;

/*
	This function is pascal call back routine.  It lanches nu apps; refer
	to pp. 118 & 119 in the ls c manual for more info.
		note:	result code < 0 means error
*/

{
	asm
	{
		move.l	8(sp),a0	/* pops ptr into a0 */
		_Launch				/* calls launch */
							/* OSErr ret'd in d0 */
	}
}

/****************************************************************************************/

OSErr DoLaunch(subLaunch)
	Boolean	subLaunch;		/* sublaunch if true & launch if false */
	
{
	LaunchStruct	myLaunch;
	Point			where;				/* where to display dialog */
	SFReply			reply;				/* reply record */
	SFTypeList		myFileTypes;		/* we only want appls */
	short int		numFileTypes = 1;
	HFileInfo		myPB;
	StringPtr		dirNameStr;
	OSErr			err;
	OSErr			LaunchIt();			/* forward declare funct */
	
	where.h = 80;
	where.v = 90;
	myFileTypes[0] = 'APPL';			/* only appls */
	
	/* let the user choose the file to launch */
	
	SFGetFile(where, "", NIL, numFileTypes, myFileTypes, NIL, &reply);
	
	if (reply.good)
	{
		dirNameStr = (StringPtr) &reply.fName;	/* init to file selected */
		
		/* get finder flags */
		
		myPB.ioCompletion = NIL;
		myPB.ioNamePtr = dirNameStr;
		myPB.ioVRefNum = reply.vRefNum;
		myPB.ioFDirIndex = 0;
		myPB.ioDirID = 0;
		err = PBGetCatInfo((CInfoPBPtr) &myPB, FALSE);
		if (err != noErr)
			return(err);	/* how to handle this? */
		
		/* set the current volume to where the target appl is */
		
		err = SetVol(NIL, reply.vRefNum);
		if (err != noErr)
			return(err);	/* ditto */
			
		/* set up the launch params */
		
		myLaunch.pfName = (StringPtr) &reply.fName;		/* ptr to our filename */
		myLaunch.param = 0;		/* we don't want alt screen or sound buffs */
			
		/* set up LC so as to tell launch that htere is non-junk next */
		
		myLaunch.LC[0] = 'L';	myLaunch.LC[1] = 'C';
		myLaunch.extBlockLen = 6;	/* len of param blk past this long word */
		
		/* copy flags; set bit 6 of low byte to 1 for RO access: */
		
		myLaunch.fFlags = myPB.ioFlFndrInfo.fdFlags;	/* from _GetCatInfo */
		
		/* test sublaunch & set launch flags accordingly */
		
		if (subLaunch)
			myLaunch.launchFlags = 0xC0000000;	/* set 2 high bit for sublaunch */
		else
			myLaunch.launchFlags = 0x00000000;	/* launch & quit */
		/* Debugger(); */
		err = LaunchIt(&myLaunch);		/* call _Launch */
		if (err < 0)
		{
		/* launch failed, put up alert to tell user */
		/* LaunchFailed();	*/
			return(err);
		}
		else
			return(noErr);
	}
}

/****************************************************************************************/

CenterPict(thePicture, myRectPtr)
	PicHandle	thePicture;
	Rect		*myRectPtr;
	
{
	Rect	windRect, 
			pictureRect;
			
	windRect = *myRectPtr;
	pictureRect = (**(thePicture)).picFrame;
	myRectPtr->top = (windRect.bottom - windRect.top - (pictureRect.bottom
						- pictureRect.top)) / 2 + windRect.top;
	myRectPtr->bottom = myRectPtr->top + (pictureRect.bottom - pictureRect.top);
	myRectPtr->left = (windRect.right - windRect.left - (pictureRect.right 
						- pictureRect.left)) / 2 + windRect.left;
	myRectPtr->right = myRectPtr->left + (pictureRect.right - pictureRect.left);
}

