(*******************************************************************
	
	Common.p
	
	Declarations for dynamic Transfer menu demo.
	
	(c) 1988, by Clifford Story & Attic Software
	
********************************************************************
	
	This is a collection of constant and type declarations, most of
	which are not used in this program.  I keep an odds-and-ends
	unit of such things that I routinely include in all my programs;
	it's too much trouble to sort out what parts are used in Windows
	and what parts aren't.
	
	In addition, there're a few program-specific type declarations
	at the bottom.  This is the structure of the TRNS resource that
	holds the menu data.
	
*******************************************************************)
	
unit Common;
	
(******************************************************************)
	
interface
	
(******************************************************************)
	
	uses memtypes, quickdraw, osintf, toolintf;
	
(*******************************************************************
	
	Key codes:
		
*******************************************************************)
	
	const
	
		enterkey				=	3;
		backspace			=	8;
		tabkey				=	9;
		returnkey			=	13;
		clearkey				=	27;
		leftarrow			=	28;
		rightarrow			=	29;
		uparrow				=	30;
		downarrow			=	31;
		periodkey			=	46;
	
(*******************************************************************
	
	Dialog items:
		
*******************************************************************)
		
		themask				=	3;
		
(*******************************************************************
	
	Low-memory globals:
		
*******************************************************************)
	
		applscratch			=	$A78;
		bootdrive			=	$210;
		curappname			=	$910;
		curdirstore			=	$398;
		currenta5			=	$904;
		findername			=	$2E0;
		fsfcblen				=	$3F6;
		grayrgn				=	$9EE;
		iaznotify			=	$33C;
		mbarheight			=	$BAA;
		menuflash			=	$A24;
		resload				=	$A5E;
		rom85					=	$28E;
		sfsavedisk			=	$214;
		sysmap				=	$A58;
		windowlist			=	$9D6;
	
(*******************************************************************
	
	Standard types:
		
*******************************************************************)

	type
		
		logical				=	boolean;
		long					=	longint;
		
		shortpointer		=	^integer;
		longpointer			=	^long;
		
		str31					=	String[31];
		
		tline					=	record
			volume			:	integer;
			directory		:	long;
			name				:	str31;
		end;
		
		trecord				=	record
			count				:	integer;
			appl				:	array [1..100] of tline;
		end;
		tpointer				=	^trecord;
		thandle				=	^tpointer;
	
(******************************************************************)
	
end.
	
(******************************************************************)
